/*
 *  v2.1   2006-06-18  Gelin   Modified and recompilied for win32
 */

//structures mustn's be aligned
//#pragma options -a1
#pragma pack(1)

#include<stdio.h>
#include<string.h>
#include<ctype.h>
#include<stdlib.h>
#include<fcntl.h>
#include<sys/stat.h>
#include<io.h>

struct ICONDIR {// 䠩 ICO
    short          wReserved;//१ࢨ஢,.. 0
    short          wType;   //⨯  - 1
    short          wCount;  //᫮   䠩
};

struct ICONDIRENTRY //ଠ  
{
    char  bWidth;      //ਭ 16,32,64
    char  bHeight;     // 16,32,64
    char  bColorCount; //᫮ 梥⮢ 2,8,16,256(?)
    char  bReserved;   //१ࢨ஢ - 0
    short  wPlanes;    //᫮ ᫮
    short  wBitCount;  //᫮   ⬠ ?
    long dwBytesInRes; //ࠧ   
    long dwImageOffset;//ᬥ饭  砫 䠩  ࠦ
};

struct BITMAPINFOHEADER// ࠦ
{
long    dwSize;     //᫮ ,  ன
            //BITMAPINFOHEADER
long    dwWidth;    //ਭ ⮢ ࠧ  ᥫ
long    dwHeight;   // ⮢ ࠧ  ᥫ
short   wPlanes;    //᫮ ⮢ ᪮⥩ ன⢠
short   wBitCount;  //᫮ ⮢  ᥫ
long    dwCompression;  //⨯ ᦠ
long    dwSizeImage;    //ࠧ ⨭  
long    dwXPelsPerMeter;//ਧ⠫쭮 ࠧ襭 ன⢠,
            //ᥫ/
long    dwYPelPerMeter; //⨪쭮 ࠧ襭 ன⢠,
            //ᥫ/
long    dwClrUsed;  //᫮ ᯮ㥬 梥⮢
long    dwClrImportant; //᫮ "" 梥⮢
};

struct RGBQUAD // 
{
char    bRed;       //⥭ᨢ ᭮
char    bGreen;         //⥭ᨢ 
char    bBlue;          //⥭ᨢ 㡮
char    bReserved;  // ᯮ
};

struct BITMAPFILEHEADER // 䠩 BMP
{
short   wType;      //⨯ 䠩 ( ⮢ ࠧ - BM)
long    dwSize;     //ࠧ 䠩  long
short   wReserved1; // ᯮ
short   wReserved2; // ᯮ
long    dwOffbits;  //ᬥ饭  ⮢ ࠧ
};

char* icofile; // 䠩-

struct bmpfile //ᢥ   bmp-䠩
{
 char* filename; // 䠩
 int width;      //ਭ ⨭
 int height;     // ⨭
 int bytewidth;  //᫮ ,  ப ⨭
 int bitcount;   //  ᥫ
 int transX;     //न ஧筮 窨
 int transY;
 int invX;       //न ᭮ 窨
 int invY;
 int showpalette; //뢠  
 int showimage;   //뢠  ⨭
};

int numbmpfiles=0; //᫮ bmp-襪
bmpfile* bmpfiles; //ᨢ bmp-襪

//ᮮ饭  訡  室
void Error(char* msg, char* str=NULL);
//ࠧ 㬥⮢
void ParseArgs(int,char**);
//ᮮ饭  ᯮ짮  室
void Usage(char* msg, char* str=NULL);
//뢠 ⨭
void ShowImage(void* img,int Xsize,int Ysize,RGBQUAD* rgb,int bpcol);
// ᥫ  न⠬
int GetPixel(void *ptr,int x,int y,int Xsize,int Ysize,int bpcol);
// ᥫ  न⠬
void SetPixel(void *ptr,int x,int y,int Xsize,int Ysize,int bpcol,unsigned char col);

void main(int argc,char *argv[])
{
 int i,j,x,y;
 int ico;
 printf("\nBMPtoICO v.2.1 (c) Gelin, 2003-2006\n");       //祪
 ParseArgs(argc, argv); //ࠧࠥ ࠬ

 printf("> Icon file: %s\n",icofile);
 //_fmode=O_BINARY;
 if((ico=open(icofile,O_WRONLY|O_CREAT|O_BINARY|O_EXCL,S_IREAD|S_IWRITE))<0)    //뢠   
  Error("! Can't write to %s (file already exists?)\n",icofile);
 ICONDIR* icondir;
 if(!(icondir=(ICONDIR*)malloc(sizeof(ICONDIR)))) //뤥塞   ICONDIR
  Error("! Can't alloc ICONDIR\n");
 icondir->wReserved=0;         //塞
 icondir->wType=1;
 icondir->wCount=numbmpfiles;
 if(write(ico,icondir,sizeof(ICONDIR))>0)       //뢠
  printf("- ICONDIR written.\n");
 else
  Error("! Can't write ICONDIR\n");
 free(icondir);      //᢮ 

 int bmp;
 BITMAPFILEHEADER* bmpfilehead; // bmp-䠩
 if(!(bmpfilehead=(BITMAPFILEHEADER*)malloc(sizeof(BITMAPFILEHEADER))))
  Error("! Can't alloc BITMAPFILEHEADER\n");
 BITMAPINFOHEADER* bmpinfohead; // ଠ樨  ࠦ
 if(!(bmpinfohead=(BITMAPINFOHEADER*)malloc(sizeof(BITMAPINFOHEADER))))
  Error("! Can't alloc BITMAPINFOHEADER\n");
 long tmp;
 ICONDIRENTRY* icondirentry;    //    䠩 ico
 if(!(icondirentry=(ICONDIRENTRY*)malloc(sizeof(ICONDIRENTRY))))
  Error("! Can't alloc ICONDIRENTRY\n");
 long offset = sizeof(ICONDIR)+sizeof(ICONDIRENTRY)*numbmpfiles; //ᬥ饭 । ࠦ  䠩 ico

 for(i=0;i<numbmpfiles;i++) // ᥬ bmp-䠩
 {
  printf("> Bitmap file: %s\n",bmpfiles[i].filename);
  if((bmp=open(bmpfiles[i].filename,O_RDONLY|O_BINARY))<0)  //뢠
   Error("! Can't read from %s\n",bmpfiles[i].filename);
  if(read(bmp,bmpfilehead,sizeof(BITMAPFILEHEADER))<=0) //⠥  䠩
   Error("! Can't read BITMAPFILEHEADER\n");
  if(bmpfilehead->wType != ('M'<<8)+'B') //  㪢   BM
   Error("! This is not bitmap file\n");
  printf("+ file size: %li bytes\n",bmpfilehead->dwSize); //ਬ ࠧ
  if(read(bmp,bmpinfohead,sizeof(BITMAPINFOHEADER))<=0) //⠥  ࠦ
   Error("! Can't read BITMAPINFOHEADER\n");
  bmpfiles[i].width=(int)bmpinfohead->dwWidth;  // ࠧ ⨭
  bmpfiles[i].height=(int)bmpinfohead->dwHeight;
  printf("+ picture size: %ix%i\n",bmpfiles[i].width,bmpfiles[i].height);
  if(!((bmpfiles[i].width==16 && bmpfiles[i].height==16)
     ||(bmpfiles[i].width==32 && bmpfiles[i].height==32)
     ||(bmpfiles[i].width==64 && bmpfiles[i].height==64)))
   Error("! Image size must be 16x16, 32x32 or 64x64\n"); //஢塞 ࠭祭  ࠧ ⨭
  bmpfiles[i].bitcount=bmpinfohead->wBitCount; //   ᥫ
  printf("+ bits per pixel: %i\n",bmpfiles[i].bitcount);
  if(bmpfiles[i].bitcount!=1&&bmpfiles[i].bitcount!=2
     &&bmpfiles[i].bitcount!=4&&bmpfiles[i].bitcount!=8)
   Error("! Image must be 2 or 4 or 16 or 256 colors\n"); //஢塞 ࠭祭  ᫮ 梥⮢
  bmpfiles[i].bytewidth=bmpfiles[i].width/8*bmpfiles[i].bitcount; //뢠  ப , ஢  32 ⭮ ࠭
  bmpfiles[i].bytewidth+=bmpfiles[i].bytewidth%4; //32bit range
  tmp=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER) //ࠧ 
   +(1<<bmpfiles[i].bitcount)*sizeof(RGBQUAD)           //ࠧ 
   +bmpfiles[i].bytewidth*bmpfiles[i].height;           //ࠧ ࠦ
  printf("+ calculated file size: %li bytes\n",tmp);
  if(bmpfilehead->dwSize != tmp) //஢塞 ࠧ 䠩
   Error("! Real size and calculated size are not equal\n\
! May be compressed image? Use MS Paint!\n");

  icondirentry->bWidth = bmpfiles[i].width;     // ࠧ  ࠬ 
  icondirentry->bHeight = bmpfiles[i].height;
  icondirentry->bColorCount = (1<<bmpfiles[i].bitcount);//᫮ 梥⮢
  icondirentry->bReserved = 0;
  icondirentry->wPlanes = 0;
  //icondirentry->wBitCount = bmpfiles[i].bitcount; //  ᥫ
  icondirentry->wBitCount = 0; //  ᥫ??
  icondirentry->dwBytesInRes = bmpinfohead->dwSizeImage //picture size
    +sizeof(BITMAPINFOHEADER)                      //header size
    +(bmpfiles[i].width+bmpfiles[i].width%32)*bmpfiles[i].height/8   //mask size
    +(1<<bmpfiles[i].bitcount)*sizeof(RGBQUAD);  //palette size
  icondirentry->dwImageOffset = offset; //ᬥ饭 ⨭  䠩
  offset += icondirentry->dwBytesInRes; // 㤥 ᫥ ⨭
  if(write(ico,icondirentry,sizeof(ICONDIRENTRY))>0) //뢠
   printf("- ICONDIRENTRY written.\n");
  else
   Error("! Can't write ICONDIRENTRY\n");

  close(bmp);
 }

 free(icondirentry); //᢮  
 free(bmpfilehead);

 RGBQUAD* rgbquads; //
 int numcol;        //ࠧ 
 int black,white;   //
 RGBQUAD blackrgb,whitergb; // RGB   ୮ 梥⮢
 int trans,inv;             //
 RGBQUAD transrgb,invrgb;   // RGB ஧筮  ᭮ 梥⮢

 for(i=0;i<numbmpfiles;i++) //  bmp
 {
  printf("> Bitmap file: %s\n",bmpfiles[i].filename);
  if((bmp=open(bmpfiles[i].filename,O_RDONLY|O_BINARY))<0)  //뢠
   Error("! Can't read from %s\n",bmpfiles[i].filename);
  if(lseek(bmp,sizeof(BITMAPFILEHEADER),SEEK_SET)<=0) //ய᪠  䠩
   Error("! Can't skip BITMAPFILEHEADER\n");

  if(read(bmp,bmpinfohead,sizeof(BITMAPINFOHEADER))<=0) //⠥  ⨭
   Error("! Can't read BITMAPINFOHEADER\n");
  tmp=bmpinfohead->dwSizeImage+(bmpfiles[i].width+bmpfiles[i].width%32)*bmpfiles[i].height/8; //ࠧ ⨭ 㢥稢  ࠧ ᪨
  bmpinfohead->dwSize=sizeof(BITMAPINFOHEADER);
  bmpinfohead->dwHeight*=2; // ⠪ 㢥稢   ᪨
  bmpinfohead->wPlanes=1;
  bmpinfohead->dwCompression=0;
  bmpinfohead->dwSizeImage=tmp; // ࠧ
  bmpinfohead->dwXPelsPerMeter=0;
  bmpinfohead->dwYPelPerMeter=0;
  bmpinfohead->dwClrUsed=0;
  bmpinfohead->dwClrImportant=0;
  if(write(ico,bmpinfohead,sizeof(BITMAPINFOHEADER))>0) //뢠  ࠦ
   printf("- BITMAPINFOHEADER written.\n");
  else
   Error("! Can't write BITMAPINFOHEADER\n");

  numcol=(1<<bmpfiles[i].bitcount); //᫮ 梥⮢
  if(!(rgbquads=(RGBQUAD*)malloc(sizeof(RGBQUAD)*numcol))) //뤥塞   
   Error("! Can't alloc RGBQUADs\n");
  if(read(bmp,rgbquads,sizeof(RGBQUAD)*numcol)<=0) //⠥ 
   Error("! Can't read RGBQUADs\n");
  black=0; //㤥 ᪠ ᠬ ⥬  ᠬ ᢥ 梥
  white=0;
  blackrgb.bRed=255; blackrgb.bGreen=255; blackrgb.bBlue=255; //᭠砫  = 
  whitergb.bRed=0; whitergb.bGreen=0; whitergb.bBlue=0;       // = 
  if(bmpfiles[i].showpalette)
   printf("Palette:\n");
  for(j=0;j<numcol;j++) // ᥬ 梥⠬
  {
   if(rgbquads[j].bRed>whitergb.bRed||rgbquads[j].bGreen>whitergb.bGreen
      ||rgbquads[j].bBlue>whitergb.bBlue) //᫨ 梥 
   {
    white=j; //  
    whitergb=rgbquads[j];
   }
   if(rgbquads[j].bRed<blackrgb.bRed||rgbquads[j].bGreen<blackrgb.bGreen
      ||rgbquads[j].bBlue<blackrgb.bBlue) //᫨ 梥 ⥬
   {
    black=j; //  
    blackrgb=rgbquads[j];
   }
   if(bmpfiles[i].showpalette) //᫨  - 뢮 
    printf("%i\t(%i,%i,%i)\n",j,rgbquads[j].bRed,rgbquads[j].bGreen,rgbquads[j].bBlue);
  }
  printf("+ blackest color: %i (%i,%i,%i)\n",black,blackrgb.bRed,blackrgb.bGreen,
                                          blackrgb.bBlue);
  printf("+ whitest color: %i (%i,%i,%i)\n",white,whitergb.bRed,whitergb.bGreen,
                                          whitergb.bBlue);
  if(write(ico,rgbquads,sizeof(RGBQUAD)*numcol)>0) //뢠   
   printf("- RGBQUADs written.\n");
  else
   Error("! Can't write RGBQUADs\n");

  void* image; //ࠦ
  int imgsize=bmpfiles[i].bytewidth*bmpfiles[i].height; //ࠧ  
  if(!(image=malloc(imgsize))) //뤥塞 
   Error("! Can't alloc IMAGE\n");
  if(read(bmp,image,imgsize)<=0) //⠥
   Error("! Can't read IMAGE\n");
  if(bmpfiles[i].showimage) //᫨  㥬
   ShowImage(image,bmpfiles[i].width,bmpfiles[i].height,rgbquads,bmpfiles[i].bitcount);

  void* mask; //᪠
  int masksize=(bmpfiles[i].width+bmpfiles[i].width%32)*bmpfiles[i].height/8; //ࠧ ᪨
  if(!(mask=malloc(masksize))) //뤥塞 
   Error("! Can't alloc MASK\n");
  memset(mask,0,masksize); //塞 ﬨ

  if(bmpfiles[i].transX>-1) //㦭 ஧筮
  {
   trans=GetPixel(image,bmpfiles[i].transX,bmpfiles[i].transY,bmpfiles[i].width,bmpfiles[i].height,bmpfiles[i].bitcount);
   transrgb=rgbquads[trans]; //室 ࠬ ஧筮 ᥫ
   printf("+ transparent: %i:%i %i (%i,%i,%i)\n",bmpfiles[i].transX,bmpfiles[i].transY,trans,transrgb.bRed,transrgb.bGreen,transrgb.bBlue);
   for(y=0;y<bmpfiles[i].height;y++) // ᥬ 窠
    for(x=0;x<bmpfiles[i].width;x++)
     if(GetPixel(image,x,y,bmpfiles[i].width,bmpfiles[i].height,bmpfiles[i].bitcount)==trans) //᫨ 窠   ஧筮
     {
      SetPixel(image,x,y,bmpfiles[i].width,bmpfiles[i].height,bmpfiles[i].bitcount,black); // ࠦ - ୠ 窠
      SetPixel(mask,x,y,bmpfiles[i].width,bmpfiles[i].height,1,1); // ᪥ - 1
     }
  }

  if(bmpfiles[i].invX>-1)   //㦭 
  {
   inv=GetPixel(image,bmpfiles[i].invX,bmpfiles[i].invY,bmpfiles[i].width,bmpfiles[i].height,bmpfiles[i].bitcount);
   invrgb=rgbquads[inv]; //室 ࠬ ᭮ ᥫ
   printf("+ inverted: %i:%i %i (%i,%i,%i)\n",bmpfiles[i].invX,bmpfiles[i].invY,inv,invrgb.bRed,invrgb.bGreen,invrgb.bBlue);
   for(y=0;y<bmpfiles[i].height;y++) // ᥬ 窠
    for(x=0;x<bmpfiles[i].width;x++)
     if(GetPixel(image,x,y,bmpfiles[i].width,bmpfiles[i].height,bmpfiles[i].bitcount)==inv) //᫨ 窠   ᭮
     {
      SetPixel(image,x,y,bmpfiles[i].width,bmpfiles[i].height,bmpfiles[i].bitcount,white); // ࠦ -  窠
      SetPixel(mask,x,y,bmpfiles[i].width,bmpfiles[i].height,1,1); // ᪥ - 1
     }
  }

  if(write(ico,image,imgsize)>0) //襬 ⨭
   printf("- IMAGE written.\n");
  else
   Error("! Can't write IMAGE\n");
  if(write(ico,mask,masksize)>0) //뢠 
   printf("- MASK written.\n");
  else
   Error("! Can't write MASK\n");

  free(mask); //᢮ 
  free(image);
  free(rgbquads);

  close(bmp); //뢠
 }

 free(bmpinfohead); //᢮

 close(ico); //뢠
 printf("%s closed.\n",icofile);
 free(bmpfiles);
}

//뢮 ᮮ饭  訡
void Error(char* msg, char* str)
{
 if(str)
  fprintf(stderr,msg,str);
 else
  fprintf(stderr,msg);
 exit(1);
}

//ࠧࠥ 㬥
void ParseArgs(int argc, char* argv[])
{
 int i;
 if(argc<3)
  Usage("Too few arguments!");
 icofile=argv[argc-1];
 for(i=1;i<argc-1;i++)
  if(argv[i][0]!='-'&&argv[i][0]!='/')
   numbmpfiles++;
 bmpfiles=(bmpfile*)malloc(sizeof(bmpfile)*numbmpfiles);
 for(i=0;i<numbmpfiles;i++)
 {
  bmpfiles[i].filename=NULL;
  bmpfiles[i].transX=-1;
  bmpfiles[i].transY=-1;
  bmpfiles[i].invX=-1;
  bmpfiles[i].invY=-1;
  bmpfiles[i].showpalette=0;
  bmpfiles[i].showimage=0;
 }
 int n=0;
 char* str;
 for(i=1;i<argc-1;i++)
 {
  if(argv[i][0]=='-'||argv[i][0]=='/')
   switch(argv[i][1])
   {
    case 't':
     str=strchr(argv[i]+2,':');
     if(!str) Usage("Syntax error in argument -t");
     str[0]=0;
     bmpfiles[n].transX=atoi(argv[i]+2);
     bmpfiles[n].transY=atoi(str+1);
    break;
    case 'i':
     str=strchr(argv[i]+2,':');
     if(!str) Usage("Syntax error in argument -i");
     str[0]=0;
     bmpfiles[n].invX=atoi(argv[i]+2);
     bmpfiles[n].invY=atoi(str+1);
    break;
    case 's':
     if(argv[i][2]=='p') bmpfiles[n].showpalette=1;
     else if (argv[i][2]=='i') bmpfiles[n].showimage=1;
     else Usage("\nUnknown option %s!\n",argv[i]);
    break;
    default:
     Usage("\nUnknown option %s!\n",argv[i]);
   }
  else
  {
   bmpfiles[n].filename=argv[i];
   n++;
  }
 }
}

//᪠뢠,  ᯮ짮
void Usage(char* msg, char* str)
{
 if(msg)
 {
  if(!str)
   fprintf(stderr,"\n%s\n",msg);
  else
   fprintf(stderr,msg,str);
 }
 printf("Usage: bmp2ico [keys] *.bmp [[keys] *.bmp ...] *.ico\n");
 printf("Keys:  -tXX:YY for transparency\n");
 printf("       -iXX:YY for inversion\n");
 printf("       -sp     show palette\n");
 printf("       -si     show image\n");
 exit(1);
}

//뢠 ⨭
void ShowImage(void* img,int Xsize,int Ysize,RGBQUAD* rgb,int bpcol)
{
 int i,j;
 int p;
 char col;
 char* pal=" .,-+=:;x!*%$&@#";
 printf("Image:\n");
 for(j=0;j<Ysize;j++)
 {
  for(i=0;i<Xsize;i++)
  {
   p=GetPixel(img,i,j,Xsize,Ysize,bpcol);
   col=(0.299*rgb[p].bRed+0.587*rgb[p].bGreen+0.114*rgb[p].bBlue)/16.0;
   printf("%c",pal[col]);
  }
  printf("\n");
 }
}

//뤠 ᥫ
int GetPixel(void *ptr,int x,int y,int Xsize,int Ysize,int bpcol)
{
 int offset=0;
 int i;
 int ppb=(8/bpcol);
 int bytewidth=Xsize/8*bpcol;
 bytewidth+=bytewidth%4;
 offset+=bytewidth*(Ysize-y-1);
 offset+=x/ppb;
 unsigned char mask=0;
 for(i=0;i<bpcol;i++)
 {
  mask>>=1;
  mask|=0x80;
 }
 //mask<<=1;
 int bytepos=x%ppb;
 mask>>=bytepos*bpcol;
 return (((unsigned char*)ptr)[offset]&mask)>>(8-bpcol-bytepos*bpcol);
}

//뢠 ᥫ
void SetPixel(void *ptr,int x,int y,int Xsize,int Ysize,int bpcol,unsigned char col)
{
 int offset=0;
 int i;
 int ppb=(8/bpcol);
 int bytewidth=Xsize/8*bpcol;
 bytewidth+=bytewidth%4;
 offset+=bytewidth*(Ysize-y-1);
 offset+=x/ppb;
 unsigned char mask=0;
 for(i=0;i<bpcol;i++)
 {
  mask>>=1;
  mask|=0x80;
 }
 //mask<<=1;
 int bytepos=x%ppb;
 ((unsigned char*)ptr)[offset]&=(~(mask>>(bytepos*bpcol)));
 ((unsigned char*)ptr)[offset]|=((col<<(8-bpcol))&mask)>>(bytepos*bpcol);
}
