#include<stdio.h>
#include<string.h>
#include<iostream.h>
#include<ctype.h>
#include<stdlib.h>
#include<conio.h>

struct ICONDIRENTRY {  //ଠ  
    char  bWidth;    //ਭ 16,32,64
    char  bHeight;   // 16,32,64
    char  bColorCount; //᫮ 梥⮢ 2,8,16
    char  bReserved;  //१ࢨ஢ - 0
    short  wPlanes;   //᫮ ᫮
    short  wBitCount;    //᫮   ⬠ ?
    long dwBytesInRes; //ࠧ   
    long dwImageOffset;     //ᬥ饭  砫 䠩  ࠦ
};

struct ICONDIR {// 䠩 ICO
    short          idReserved;//१ࢨ஢,.. 0
    short          idType;   //⨯  - 1
    short          idCount;  //᫮   䠩
    ICONDIRENTRY  idEntries[1];   //ᨢ ଠ樨  
} ICONHEADER;

struct BITMAPINFOHEADER// ࠦ
{
long	biSize;		//᫮ ,  ன
			//BITMAPINFOHEADER
long	biWidth;	//ਭ ⮢ ࠧ  ᥫ
long	biHeight;	// ⮢ ࠧ  ᥫ
short	biPlanes;	//᫮ ⮢ ᪮⥩ ன⢠
short	biBitCount;	//᫮ ⮢  ᥫ
long	biCompression;	//⨯ ᦠ
long	biSizeImage;	//ࠧ ⨭  
long	biXPelsPerMeter;//ਧ⠫쭮 ࠧ襭 ன⢠,
			//ᥫ/
long	biYPelPerMeter;	//⨪쭮 ࠧ襭 ன⢠,
			//ᥫ/
long	biClrUsed;	//᫮ ᯮ㥬 梥⮢
long	biClrImportant; //᫮ "" 梥⮢
};

struct RGBQUAD
{// 
char	rgbRed;		//⥭ᨢ ᭮
char	rgbGreen;	//⥭ᨢ 
char	rgbBlue;	//⥭ᨢ 㡮
char	rgbRserved;	// ᯮ
};


//  ⮨ :
BITMAPINFOHEADER    icHeader;    // ⬠
RGBQUAD             icColors;  //⠡ 梥⮢
char                icXOR;   //ᠬ ࠦ
char                icAND=0;  //⮢ ᪠.

struct BITMAPFILEHEADER// 䠩 BMP
{
short	bfType;		//⨯ 䠩 ( ⮢ ࠧ - BM)
long	bfSize;		//ࠧ 䠩  long
short	bfReserved1;	// ᯮ
short	bfReserved2;	// ᯮ
long	bfOffbits;	//ᬥ饭  ⮢ ࠧ 
} BMPHEADER;

int GetPixel(void *ptr,int x,int y,int Xsize,int Ysize,int bpcol);
void SetPixel(void *ptr,int x,int y,int Xsize,int Ysize,int bpcol,unsigned char col);

void main(int argc,char *argv[])
{
 cout<<endl<<endl;
 long i,j;
 FILE *bmp,*ico;
 if(argc>=2)
 {
  for(i=0;i<strlen(argv[1]);i++)
   argv[1][i]=tolower(argv[1][i]);
 }
 if(strstr(argv[1],".bmp"))
 {
  bmp=fopen(argv[1],"rb");
  if(!bmp)return;
  fread(&BMPHEADER,sizeof(BITMAPFILEHEADER),1,bmp);//⠥  䠩
  fread(&icHeader,sizeof(BITMAPINFOHEADER),1,bmp); // ࠦ
  if((icHeader.biWidth!=16&&icHeader.biWidth!=32&&icHeader.biWidth!=64)||(icHeader.biHeight!=16&&icHeader.biHeight!=32&&icHeader.biHeight!=64))
  {
   cout<<"Bitmap Image Size must be 16x16 or 32x32 or 64x64."<<endl;
   return;
  }
  if(icHeader.biBitCount!=1&&icHeader.biBitCount!=2&&icHeader.biBitCount!=4&&icHeader.biBitCount!=8)
  {
   cout<<"Image must be 2 or 4 or 16 or 256 color."<<endl;
   return;
  }
  if(BMPHEADER.bfSize<(sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+(1<<icHeader.biBitCount)*sizeof(RGBQUAD)+icHeader.biWidth*icHeader.biHeight/8*icHeader.biBitCount))
  {
   cout<<"File size error. May be comressed image. Use 'Paint'."<<endl;
   return;
  }
 }
 if(argc>=3)
 {
  for(i=0;i<strlen(argv[2]);i++)
   argv[2][i]=tolower(argv[2][i]);
 if(strstr(argv[2],".ico"))
 {
  int transcol=-1;
  int blackcol=0;
  int transy=-1;
  int transx=-1;
  if(argc>=5)
  {
   for(i=3;i<5;i++)
    switch(argv[i][1])
    {
     case 'X':case 'x':
      transx=atoi(argv[i]+2);
     break;
     case 'Y':case 'y':
      transy=atoi(argv[i]+2);
     break;
    }
  }
  ico=fopen(argv[2],"wb");
  if(!ico)return;
  ICONHEADER.idReserved=0;       //ନ㥬  䠩
  ICONHEADER.idType=1;
  ICONHEADER.idCount=1;
  ICONHEADER.idEntries[0].bWidth=icHeader.biWidth;
  ICONHEADER.idEntries[0].bHeight=icHeader.biHeight;
  ICONHEADER.idEntries[0].bColorCount=(1<<icHeader.biBitCount);//icHeader.biClrUsed;
  ICONHEADER.idEntries[0].bReserved=0;
  ICONHEADER.idEntries[0].wPlanes=0;
  ICONHEADER.idEntries[0].wBitCount=0; //ࠧ = ࠧ ⨭ + ࠧ  ⨭ + ࠧ ᪨ + ࠧ ⠡ 梥⮢
  ICONHEADER.idEntries[0].dwBytesInRes=icHeader.biSizeImage+sizeof(BITMAPINFOHEADER)+icHeader.biWidth*icHeader.biHeight/8+(1<<icHeader.biBitCount)*sizeof(RGBQUAD);
  ICONHEADER.idEntries[0].dwImageOffset=sizeof(ICONDIR);
  fwrite(&ICONHEADER,sizeof(ICONDIR),1,ico);//襬 
  BITMAPINFOHEADER temp;      //ନ㥬  ࠦ
  temp.biSize=sizeof(BITMAPINFOHEADER);
  temp.biWidth=icHeader.biWidth;
  temp.biHeight=icHeader.biHeight*2;
  temp.biPlanes=1;
  temp.biBitCount=icHeader.biBitCount;
  temp.biCompression=0;
  temp.biSizeImage=icHeader.biSizeImage+icHeader.biWidth*icHeader.biHeight/8;//+ ⮢ ᪠
  temp.biXPelsPerMeter=0;
  temp.biYPelPerMeter=0;
  temp.biClrUsed=0;
  temp.biClrImportant=0;
  fwrite(&temp,sizeof(BITMAPINFOHEADER),1,ico);//뢠
  void* tmp;
  tmp=malloc(sizeof(RGBQUAD)*(1<<icHeader.biBitCount));
  if(!tmp){cout<<"Not enought memory"<<endl;return;}
  //९뢠 ⠡ 梥⮢
  fread(tmp,sizeof(RGBQUAD)*(1<<icHeader.biBitCount),1,bmp);
  for(i=0;i<1<<icHeader.biBitCount;i++)
  {
   RGBQUAD* currgb=(RGBQUAD*)tmp+i;
   RGBQUAD* blkrgb=(RGBQUAD*)tmp+blackcol;
   if(currgb->rgbRed<blkrgb->rgbRed||currgb->rgbGreen<blkrgb->rgbGreen||currgb->rgbBlue<blkrgb->rgbBlue)
    blackcol=i;//室 ᠬ  梥
  }
  fwrite(tmp,sizeof(RGBQUAD)*(1<<icHeader.biBitCount),1,ico);
  free(tmp);
  tmp=malloc(icHeader.biSizeImage);
  if(!tmp){cout<<"Not enought memory"<<endl;return;}
  //⠥ ⨭
  fread(tmp,icHeader.biSizeImage,1,bmp);
  void *mask;
  mask=malloc(icHeader.biWidth*icHeader.biHeight/8);
  if(!mask){cout<<"Not enought memory"<<endl;return;}
  memset(mask,0,icHeader.biWidth*icHeader.biHeight/8);
  if(transy>-1&&transx>-1)
  {
   transcol=GetPixel(tmp,transx,transy,icHeader.biWidth,icHeader.biHeight,icHeader.biBitCount);// 梥 ஧
   if(transcol>-1)
   {
    //塞   ஧筮
    for(j=0;j<icHeader.biHeight;j++)
     for(i=0;i<icHeader.biWidth;i++)
      if(GetPixel(tmp,i,j,icHeader.biWidth,icHeader.biHeight,icHeader.biBitCount)==transcol)
       SetPixel(mask,i,j,icHeader.biWidth,icHeader.biHeight,1,1);
    // ஧筮 
    for(j=0;j<icHeader.biHeight;j++)
     for(i=0;i<icHeader.biWidth;i++)
      if(GetPixel(tmp,i,j,icHeader.biWidth,icHeader.biHeight,icHeader.biBitCount)==transcol)
       SetPixel(tmp,i,j,icHeader.biWidth,icHeader.biHeight,icHeader.biBitCount,blackcol);
   }
  }
  //襬 ࠦ
  fwrite(tmp,icHeader.biSizeImage,1,ico);
  //襬 
  fwrite(mask,icHeader.biWidth*icHeader.biHeight/8,1,ico);
  free(mask);//᢮
  free(tmp);
  fclose(bmp);       //뢠
  fclose(ico);
  cout<<"Well Done!"<<endl;
  cout<<argv[1]<<" was converted to "<<argv[2]<<endl;
  cout<<"by"<<endl;
 }
 }
 cout<<"Advanced BMP to ICO converter from Gelin"<<endl<<"usage:  bmp2ico.exe *.bmp *.ico [keys]"<<endl<<
  "Keys are /Xnn and /Ynn. nn are the coordinates of pixel with transparent color"<<endl;
}

int GetPixel(void *ptr,int x,int y,int Xsize,int Ysize,int bpcol)
{
 int offset=0;
 int i;
 int ppb=(8/bpcol);
 offset+=Xsize/ppb*(Ysize-y-1);
 offset+=x/ppb;
 unsigned char mask=0;
 for(i=0;i<bpcol;i++)
 {
  mask>>=1;
  mask|=0x80;
 }
 //mask<<=1;
 int bytepos=x%ppb;
 mask>>=bytepos*bpcol;
 return (((unsigned char*)ptr)[offset]&mask)>>(8-bpcol-bytepos*bpcol);
}

void SetPixel(void *ptr,int x,int y,int Xsize,int Ysize,int bpcol,unsigned char col)
{
 int offset=0;
 int i;
 int ppb=(8/bpcol);
 offset+=Xsize/ppb*(Ysize-y-1);
 offset+=x/ppb;
 unsigned char mask=0;
 for(i=0;i<bpcol;i++)
 {
  mask>>=1;
  mask|=0x80;
 }
 //mask<<=1;
 int bytepos=x%ppb;
 ((unsigned char*)ptr)[offset]&=(~(mask>>(bytepos*bpcol)));
 ((unsigned char*)ptr)[offset]|=((col<<(8-bpcol))&mask)>>(bytepos*bpcol);
}